<?php
include_once __DIR__ . "/classes/ShoppingFlux_Caracteristique.class.php";
include_once __DIR__ . "/classes/ShoppingFlux_Commande.class.php";
include_once(realpath(dirname(__FILE__)) . "/../../../classes/PluginsClassiques.class.php");
include_once(realpath(dirname(__FILE__)) . "/../../../classes/Commande.class.php");
include_once(realpath(dirname(__FILE__)) . "/UpdateOrders.php");

class Shoppingflux extends PluginsClassiques
{

    function __construct()
    {
        parent::__construct();
    }
    
    function init()
    {
        
		// création de la table shopping_flux 
		$query = "CREATE  TABLE IF NOT EXISTS `shopping_flux_commande` (
		`id` INT NOT NULL AUTO_INCREMENT ,
		`id_order` VARCHAR(255) NULL ,
		`market_place` VARCHAR(255) NULL ,
		`id_commande` INT NULL ,
		PRIMARY KEY (`id`) );";

		mysql_query($query);
		
		// création de la table où seront écrites les règles d'envoi (cases cochées ou non pour envoyer une caractéristique)
		$query = "CREATE  TABLE IF NOT EXISTS `caracteristiques_flux` (		
		`id` INT NOT NULL AUTO_INCREMENT ,
		`idCaracteristique` INT NOT NULL ,
		`active` BOOL NULL ,
		UNIQUE (`idCaracteristique`),
		PRIMARY KEY (`id`) );";

		mysql_query($query);
		
		$idClient=0;
		$client = new Client();
		
		// si le client n'est pas présent dans la base de données
		if(!($client->charger("shoppingFlux@shoppingFlux.org", "")))
		{
			$client->nom = "ShoppingFlux";
			$client->ref = date("ymdHis").strtoupper(ereg_caracspec(substr(strip_tags($client->nom),0, 3)));
			$client->lang = "1";
			$client->email = "shoppingFlux@shoppingFlux.org";
			$client->motdepasse = "";
			$idClient = $client->add();
			$query = "INSERT into variable (`nom`,`valeur`) values ('shoppingFlux','".$idClient."')";
			mysql_query($query); 
		}
		
		
		$caracs = array();
		$query = "SELECT id from caracteristique";
		$result = mysql_query($query);
					
		while($row = mysql_fetch_object($result)) {
            $caracs[] = $row->id;	// on ajoute à la fin
        }

		
		// maintenant on va vérifier si toutes ces caractéristiques sont présentes dans notre table
		for($i=0; $i<sizeof($caracs);$i++)
		{
			// par défaut, l'envoi de la caractéristique est activé
			$caracFlux = new ShoppingFlux_Caracteristique();
			$caracFlux->idCaracteristique = $caracs[$i];
			$caracFlux->active = 1;
			$caracFlux->add();
		}
		
		// On vérifie si toutes les caractéristique présentes dans la table sont pertinentes (des caractéristiques ont pu êtres effacées)
			// on supprime donc celles qui ne sont plus présentes dans la table "caractéristique"
		$query = "DELETE FROM caracteristiques_flux 
			WHERE idCaracteristique NOT IN 
				(SELECT id FROM caracteristique)";
				
		mysql_query($query);
    }

	function retrieveXML($xml)
	{
        $service_url = 'https://clients.shopping-flux.com/webservice/';
    
		//encapsule les données dans un tableau
		$curl_post_data = array(
        'TOKEN' => '', 
        'CALL' => 'GetOrders', 
        'MODE'=> MODEUPDDATE,
		'REQUEST' => $xml
        );

		$curl = curl_init();
		curl_setopt($curl, CURLOPT_URL, $service_url);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
		curl_setopt($curl, CURLOPT_HEADER, false);
		curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $curl_post_data);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		$curl_response = curl_exec($curl);
		curl_close($curl);
		
		return $curl_response;
	}
	
	
	public function statut(Commande $commande, $ancientStatut)
      {
		  // non payé: 1
		  // payé: 2
		  // traitement: 3
		  // envoyé: 4
            if ($commande->statut == 4) {
                //cas de passage en expédié 
                // envoi du nouveau statut
                // nous allons ici récupérer la market place grâce à l'id de la commande
                
                $query = "select market_place, id_order from shopping_flux_commande where id_commande=".$commande->id."";
                $result = mysql_query($query);
                $object = mysql_fetch_object($result);
                
                if($object!=null)
					traitementUpdate($object->id_order, $object->market_place);
            }
      }
	
	

}

?>
